diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/net/route.c head/sys/net/route.c
--- clean-head/sys/net/route.c	2013-06-26 09:37:39.000000000 +0200
+++ head/sys/net/route.c	2013-06-24 14:21:35.000000000 +0200
@@ -68,6 +68,11 @@
 
 #include <vm/uma.h>
 
+#ifdef VPS
+void vnet_route_init(const void *);
+void vnet_route_uninit(const void *);
+#endif
+
 #define	RT_MAXFIBS	UINT16_MAX
 
 /* Kernel config default option. */
@@ -163,6 +168,8 @@ rt_tables_get_rnh_ptr(int table, int fam
 
 	/* rnh is [fib=0][af=0]. */
 	rnh = (struct radix_node_head **)V_rt_tables;
+	if (rnh == NULL)
+		return (NULL);
 	/* Get the offset to the requested table and fam. */
 	rnh += table * (AF_MAX+1) + fam;
 
@@ -200,7 +207,11 @@ route_init(void)
 }
 SYSINIT(route_init, SI_SUB_PROTO_DOMAIN, SI_ORDER_THIRD, route_init, 0);
 
+#ifdef VPS
+void
+#else
 static void
+#endif
 vnet_route_init(const void *unused __unused)
 {
 	struct domain *dom;
@@ -238,7 +249,35 @@ VNET_SYSINIT(vnet_route_init, SI_SUB_PRO
     vnet_route_init, 0);
 
 #ifdef VIMAGE
+#ifdef VPS
+__unused
+static int
+vnet_route_uninit_rtdel(struct radix_node *rn, void *arg)
+{
+	struct rtentry  *rt = (struct rtentry *)rn;
+	int             err;
+
+	/*
+	 * Protect (sorta) against walktree recursion problems
+	 * with cloned routes
+	 */
+	if ((rt->rt_flags & RTF_UP) == 0)
+		return (0);
+
+	err = rtrequest_fib(RTM_DELETE, rt_key(rt), rt->rt_gateway,
+			rt_mask(rt), rt->rt_flags|RTF_RNH_LOCKED,
+			(struct rtentry **) NULL, rt->rt_fibnum);
+	if (err) {
+		log(LOG_WARNING, "%s: error %d\n", __func__, err);
+	}
+
+	return (0);
+}
+
+void
+#else
 static void
+#endif
 vnet_route_uninit(const void *unused __unused)
 {
 	int table;
@@ -247,6 +286,31 @@ vnet_route_uninit(const void *unused __u
 	struct radix_node_head **rnh;
 
 	for (dom = domains; dom; dom = dom->dom_next) {
+#if 0
+// old ...
+		if (dom->dom_rtdetach) {
+			for (table = 0; table < rt_numfibs; table++) {
+				if ( (fam = dom->dom_family) == AF_INET ||
+				    table == 0) {
+					/* For now only AF_INET has > 1 tbl. */
+					rnh = rt_tables_get_rnh_ptr(table, fam);
+					if (rnh == NULL)
+						panic("%s: rnh NULL", __func__);
+
+					/* XXX doesn't improve anything */
+					RADIX_NODE_HEAD_LOCK(*rnh);
+					(void) (*rnh)->rnh_walktree(*rnh,
+						vnet_route_uninit_rtdel, NULL);
+					RADIX_NODE_HEAD_UNLOCK(*rnh);
+
+					dom->dom_rtdetach((void **)rnh,
+					    dom->dom_rtoffset);
+				} else {
+					break;
+				}
+			}
+		}
+#else
 		if (dom->dom_rtdetach == NULL)
 			continue;
 
@@ -261,7 +325,12 @@ vnet_route_uninit(const void *unused __u
 				panic("%s: rnh NULL", __func__);
 			dom->dom_rtdetach((void **)rnh, dom->dom_rtoffset);
 		}
+#endif
 	}
+
+	uma_zdestroy(V_rtzone);
+	free(V_rt_tables, M_RTABLE);
+	V_rt_tables = NULL;
 }
 VNET_SYSUNINIT(vnet_route_uninit, SI_SUB_PROTO_DOMAIN, SI_ORDER_THIRD,
     vnet_route_uninit, 0);
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/net/rtsock.c head/sys/net/rtsock.c
--- clean-head/sys/net/rtsock.c	2013-06-26 09:37:39.000000000 +0200
+++ head/sys/net/rtsock.c	2013-06-24 14:21:35.000000000 +0200
@@ -175,7 +175,7 @@ MTX_SYSINIT(rtsock, &rtsock_mtx, "rtsock
 #define	RTSOCK_UNLOCK()	mtx_unlock(&rtsock_mtx)
 #define	RTSOCK_LOCK_ASSERT()	mtx_assert(&rtsock_mtx, MA_OWNED)
 
-static SYSCTL_NODE(_net, OID_AUTO, route, CTLFLAG_RD, 0, "");
+static _SYSCTL_NODE(_net, OID_AUTO, route, CTLFLAG_RD, 0, "", VPS_PUBLIC);
 
 struct walkarg {
 	int	w_tmemsize;
@@ -220,9 +220,9 @@ sysctl_route_netisr_maxqlen(SYSCTL_HANDL
 		return (EINVAL);
 	return (netisr_setqlimit(&rtsock_nh, qlimit));
 }
-SYSCTL_PROC(_net_route, OID_AUTO, netisr_maxqlen, CTLTYPE_INT|CTLFLAG_RW,
+_SYSCTL_PROC(_net_route, OID_AUTO, netisr_maxqlen, CTLTYPE_INT|CTLFLAG_RW,
     0, 0, sysctl_route_netisr_maxqlen, "I",
-    "maximum routing socket dispatch queue length");
+    "maximum routing socket dispatch queue length", VPS_PUBLIC);
 
 static void
 rts_init(void)
@@ -1965,7 +1965,7 @@ sysctl_rtsock(SYSCTL_HANDLER_ARGS)
 	return (error);
 }
 
-static SYSCTL_NODE(_net, PF_ROUTE, routetable, CTLFLAG_RD, sysctl_rtsock, "");
+static _SYSCTL_NODE(_net, PF_ROUTE, routetable, CTLFLAG_RD, sysctl_rtsock, "", VPS_PUBLIC);
 
 /*
  * Definitions of protocols supported in the ROUTE domain.
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/net/vnet.c head/sys/net/vnet.c
--- clean-head/sys/net/vnet.c	2013-06-26 09:37:38.000000000 +0200
+++ head/sys/net/vnet.c	2013-06-24 14:21:35.000000000 +0200
@@ -66,6 +66,8 @@ __FBSDID("$FreeBSD: head/sys/net/vnet.c 
 #include <net/if_var.h>
 #include <net/vnet.h>
 
+extern struct prison prison0;
+
 /*-
  * This file implements core functions for virtual network stacks:
  *
@@ -505,6 +507,17 @@ vnet_sysctl_handle_uint(SYSCTL_HANDLER_A
 	return (sysctl_handle_int(oidp, arg1, arg2, req));
 }
 
+#ifdef VPS
+int
+vnet_sysctl_handle_long(SYSCTL_HANDLER_ARGS)
+{
+
+	if (arg1 != NULL)
+		arg1 = (void *)(curvnet->vnet_data_base + (uintptr_t)arg1);
+	return (sysctl_handle_long(oidp, arg1, arg2, req));
+}
+#endif
+
 /*
  * Support for special SYSINIT handlers registered via VNET_SYSINIT()
  * and VNET_SYSUNINIT().
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/net/vnet.h head/sys/net/vnet.h
--- clean-head/sys/net/vnet.h	2013-06-26 09:37:38.000000000 +0200
+++ head/sys/net/vnet.h	2013-06-24 14:21:35.000000000 +0200
@@ -64,16 +64,8 @@
  */
 #if defined(_KERNEL) || defined(_WANT_VNET)
 #include <sys/queue.h>
-
-struct vnet {
-	LIST_ENTRY(vnet)	 vnet_le;	/* all vnets list */
-	u_int			 vnet_magic_n;
-	u_int			 vnet_ifcnt;
-	u_int			 vnet_sockcnt;
-	void			*vnet_data_mem;
-	uintptr_t		 vnet_data_base;
-};
-#define	VNET_MAGIC_N	0x3e0d8f29
+#include <sys/sysctl.h>
+#include <sys/vnet2.h>
 
 /*
  * These two virtual network stack allocator definitions are also required
@@ -92,17 +84,6 @@ struct vnet {
 #include <sys/sx.h>
 
 /*
- * Location of the kernel's 'set_vnet' linker set.
- */
-extern uintptr_t	*__start_set_vnet;
-__GLOBL(__start_set_vnet);
-extern uintptr_t	*__stop_set_vnet;
-__GLOBL(__stop_set_vnet);
-
-#define	VNET_START	(uintptr_t)&__start_set_vnet
-#define	VNET_STOP	(uintptr_t)&__stop_set_vnet
-
-/*
  * Functions to allocate and destroy virtual network stacks.
  */
 struct vnet *vnet_alloc(void);
@@ -180,6 +161,7 @@ extern struct vnet *vnet0;
 #define	IS_DEFAULT_VNET(arg)	((arg) == vnet0)
 
 #define	CRED_TO_VNET(cr)	(cr)->cr_prison->pr_vnet
+
 #define	TD_TO_VNET(td)		CRED_TO_VNET((td)->td_ucred)
 #define	P_TO_VNET(p)		CRED_TO_VNET((p)->p_ucred)
 
@@ -205,27 +187,6 @@ extern struct sx vnet_sxlock;
 #define	VNET_FOREACH(arg)	LIST_FOREACH((arg), &vnet_head, vnet_le)
 
 /*
- * Virtual network stack memory allocator, which allows global variables to
- * be automatically instantiated for each network stack instance.
- */
-#define	VNET_NAME(n)		vnet_entry_##n
-#define	VNET_DECLARE(t, n)	extern t VNET_NAME(n)
-#define	VNET_DEFINE(t, n)	t VNET_NAME(n) __section(VNET_SETNAME) __used
-#define	_VNET_PTR(b, n)		(__typeof(VNET_NAME(n))*)		\
-				    ((b) + (uintptr_t)&VNET_NAME(n))
-
-#define	_VNET(b, n)		(*_VNET_PTR(b, n))
-
-/*
- * Virtualized global variable accessor macros.
- */
-#define	VNET_VNET_PTR(vnet, n)		_VNET_PTR((vnet)->vnet_data_base, n)
-#define	VNET_VNET(vnet, n)		(*VNET_VNET_PTR((vnet), n))
-
-#define	VNET_PTR(n)		VNET_VNET_PTR(curvnet, n)
-#define	VNET(n)			VNET_VNET(curvnet, n)
-
-/*
  * Virtual network stack allocator interfaces from the kernel linker.
  */
 void	*vnet_data_alloc(int size);
@@ -239,11 +200,68 @@ void	 vnet_data_free(void *start_arg, in
  * Note: SYSCTL_PROC() handler functions will need to resolve pointer
  * arguments themselves, if required.
  */
-#ifdef SYSCTL_OID
+//#ifdef SYSCTL_OID
 int	vnet_sysctl_handle_int(SYSCTL_HANDLER_ARGS);
 int	vnet_sysctl_handle_opaque(SYSCTL_HANDLER_ARGS);
 int	vnet_sysctl_handle_string(SYSCTL_HANDLER_ARGS);
 int	vnet_sysctl_handle_uint(SYSCTL_HANDLER_ARGS);
+int	vnet_sysctl_handle_long(SYSCTL_HANDLER_ARGS);
+int	vnet_sysctl_handle_ulong(SYSCTL_HANDLER_ARGS);
+
+#ifdef VPS
+
+#define	_SYSCTL_VNET_INT(parent, nbr, name, access, ptr, val, descr, vps0)	\
+	_SYSCTL_OID(parent, nbr, name,					\
+	    CTLTYPE_INT|CTLFLAG_MPSAFE|CTLFLAG_VNET|(access),		\
+	    ptr, val, vnet_sysctl_handle_int, "I", descr, vps0)
+#define	_SYSCTL_VNET_PROC(parent, nbr, name, access, ptr, arg, handler,	\
+	    fmt, descr, vps0)							\
+	_SYSCTL_OID(parent, nbr, name, CTLFLAG_VNET|(access), ptr, arg, 	\
+	    handler, fmt, descr, vps0)
+#define	_SYSCTL_VNET_OPAQUE(parent, nbr, name, access, ptr, len, fmt,	\
+	    descr, vps0)						\
+	_SYSCTL_OID(parent, nbr, name,					\
+	    CTLTYPE_OPAQUE|CTLFLAG_VNET|(access), ptr, len, 		\
+	    vnet_sysctl_handle_opaque, fmt, descr, vps0)
+#define	_SYSCTL_VNET_STRING(parent, nbr, name, access, arg, len, descr, vps0)	\
+	_SYSCTL_OID(parent, nbr, name,					\
+	    CTLTYPE_STRING|CTLFLAG_VNET|(access),			\
+	    arg, len, vnet_sysctl_handle_string, "A", descr, vps0)
+#define	_SYSCTL_VNET_STRUCT(parent, nbr, name, access, ptr, type, descr, vps0)	\
+	_SYSCTL_OID(parent, nbr, name,					\
+	    CTLTYPE_OPAQUE|CTLFLAG_VNET|(access), ptr,			\
+	    sizeof(struct type), vnet_sysctl_handle_opaque, "S," #type,	\
+	    descr, vps0)
+#define	_SYSCTL_VNET_UINT(parent, nbr, name, access, ptr, val, descr, vps0)	\
+	_SYSCTL_OID(parent, nbr, name,					\
+	    CTLTYPE_UINT|CTLFLAG_MPSAFE|CTLFLAG_VNET|(access),		\
+	    ptr, val, vnet_sysctl_handle_uint, "IU", descr, vps0)
+#define	_SYSCTL_VNET_ULONG(parent, nbr, name, access, ptr, val, descr, vps0)	\
+	_SYSCTL_OID(parent, nbr, name,					\
+	    CTLTYPE_ULONG|CTLFLAG_MPSAFE|CTLFLAG_VNET|(access),		\
+	    ptr, val, vnet_sysctl_handle_long, "LU", descr, vps0)
+#define	VNET_SYSCTL_ARG(req, arg1) do {					\
+	if (arg1 != NULL)						\
+		arg1 = (void *)(TD_TO_VNET((req)->td)->vnet_data_base +	\
+		    (uintptr_t)(arg1));					\
+} while (0)
+
+#define SYSCTL_VNET_INT(parent, nbr, name, access, ptr, val, descr) \
+	_SYSCTL_VNET_INT(parent, nbr, name, access, ptr, val, descr, VPS_PUBLIC)
+#define SYSCTL_VNET_PROC(parent, nbr, name, access, ptr, arg, handler, fmt, descr) \
+	_SYSCTL_VNET_PROC(parent, nbr, name, access, ptr, arg, handler, fmt, descr, VPS_PUBLIC)
+#define SYSCTL_VNET_OPAQUE(parent, nbr, name, access, ptr, len, fmt, descr) \
+	_SYSCTL_VNET_OPAQUE(parent, nbr, name, access, ptr, len, fmt, descr, VPS_PUBLIC)
+#define SYSCTL_VNET_STRING(parent, nbr, name, access, arg, len, descr) \
+	_SYSCTL_VNET_STRING(parent, nbr, name, access, arg, len, descr, VPS_PUBLIC)
+#define SYSCTL_VNET_STRUCT(parent, nbr, name, access, ptr, type, descr) \
+	_SYSCTL_VNET_STRUCT(parent, nbr, name, access, ptr, type, descr, VPS_PUBLIC)
+#define SYSCTL_VNET_UINT(parent, nbr, name, access, ptr, val, descr) \
+	_SYSCTL_VNET_UINT(parent, nbr, name, access, ptr, val, descr, VPS_PUBLIC)
+#define SYSCTL_VNET_ULONG(parent, nbr, name, access, ptr, val, descr) \
+	_SYSCTL_VNET_ULONG(parent, nbr, name, access, ptr, val, descr, VPS_PUBLIC)
+
+#else /* VPS */
 
 #define	SYSCTL_VNET_INT(parent, nbr, name, access, ptr, val, descr)	\
 	SYSCTL_OID(parent, nbr, name,					\
@@ -272,12 +290,19 @@ int	vnet_sysctl_handle_uint(SYSCTL_HANDL
 	SYSCTL_OID(parent, nbr, name,					\
 	    CTLTYPE_UINT|CTLFLAG_MPSAFE|CTLFLAG_VNET|(access),		\
 	    ptr, val, vnet_sysctl_handle_uint, "IU", descr)
+#define	SYSCTL_VNET_ULONG(parent, nbr, name, access, ptr, val, descr)	\
+	SYSCTL_OID(parent, nbr, name,					\
+	    CTLTYPE_ULONG|CTLFLAG_MPSAFE|CTLFLAG_VNET|(access),		\
+	    ptr, val, vnet_sysctl_handle_ulong, "LU", descr)
 #define	VNET_SYSCTL_ARG(req, arg1) do {					\
 	if (arg1 != NULL)						\
 		arg1 = (void *)(TD_TO_VNET((req)->td)->vnet_data_base +	\
 		    (uintptr_t)(arg1));					\
 } while (0)
-#endif /* SYSCTL_OID */
+
+#endif /* !VPS */
+
+//#endif /* SYSCTL_OID */
 
 /*
  * Virtual sysinit mechanism, allowing network stack components to declare
@@ -384,28 +409,10 @@ do {									\
 #define	P_TO_VNET(p)		NULL
 
 /*
- * Versions of the VNET macros that compile to normal global variables and
- * standard sysctl definitions.
- */
-#define	VNET_NAME(n)		n
-#define	VNET_DECLARE(t, n)	extern t n
-#define	VNET_DEFINE(t, n)	t n
-#define	_VNET_PTR(b, n)		&VNET_NAME(n)
-
-/*
- * Virtualized global variable accessor macros.
- */
-#define	VNET_VNET_PTR(vnet, n)		(&(n))
-#define	VNET_VNET(vnet, n)		(n)
-
-#define	VNET_PTR(n)		(&(n))
-#define	VNET(n)			(n)
-
-/*
  * When VIMAGE isn't compiled into the kernel, virtaulized SYSCTLs simply
  * become normal SYSCTLs.
  */
-#ifdef SYSCTL_OID
+//#ifdef SYSCTL_OID
 #define	SYSCTL_VNET_INT(parent, nbr, name, access, ptr, val, descr)	\
 	SYSCTL_INT(parent, nbr, name, access, ptr, val, descr)
 #define	SYSCTL_VNET_PROC(parent, nbr, name, access, ptr, arg, handler,	\
@@ -421,8 +428,10 @@ do {									\
 	SYSCTL_STRUCT(parent, nbr, name, access, ptr, type, descr)
 #define	SYSCTL_VNET_UINT(parent, nbr, name, access, ptr, val, descr)	\
 	SYSCTL_UINT(parent, nbr, name, access, ptr, val, descr)
+#define	SYSCTL_VNET_ULONG(parent, nbr, name, access, ptr, val, descr)	\
+	SYSCTL_ULONG(parent, nbr, name, access, ptr, val, descr)
 #define	VNET_SYSCTL_ARG(req, arg1)
-#endif /* SYSCTL_OID */
+//#endif /* SYSCTL_OID */
 
 /*
  * When VIMAGE isn't compiled into the kernel, VNET_SYSINIT/VNET_SYSUNINIT
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/netinet/in_proto.c head/sys/netinet/in_proto.c
--- clean-head/sys/netinet/in_proto.c	2013-06-26 09:35:37.000000000 +0200
+++ head/sys/netinet/in_proto.c	2013-06-24 14:20:40.000000000 +0200
@@ -100,7 +100,7 @@ static struct pr_usrreqs nousrreqs;
 #include <netinet/sctp_var.h>
 #endif /* SCTP */
 
-FEATURE(inet, "Internet Protocol version 4");
+_FEATURE(inet, "Internet Protocol version 4", VPS_PUBLIC);
 
 extern	struct domain inetdomain;
 
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/netinet/in_rmx.c head/sys/netinet/in_rmx.c
--- clean-head/sys/netinet/in_rmx.c	2013-06-26 09:35:36.000000000 +0200
+++ head/sys/netinet/in_rmx.c	2013-06-24 14:20:39.000000000 +0200
@@ -315,6 +315,8 @@ in_rtqdrain(void)
 
 		for ( fibnum = 0; fibnum < rt_numfibs; fibnum++) {
 			rnh = rt_tables_get_rnh(fibnum, AF_INET);
+			if (rnh == NULL)
+				continue;
 			arg.found = arg.killed = 0;
 			arg.rnh = rnh;
 			arg.nextstop = 0;
@@ -372,11 +374,67 @@ in_inithead(void **head, int off)
 }
 
 #ifdef VIMAGE
+__attribute__ ((unused))
+static int
+in_rtqkill_hard(struct radix_node *rn, void *rock)
+{
+	struct rtqk_arg *ap = rock;
+	struct rtentry *rt = (struct rtentry *)rn;
+	int err;
+
+	RADIX_NODE_HEAD_WLOCK_ASSERT(ap->rnh);
+
+	if (1) {
+		ap->found++;
+
+		if (1) {
+			if (0 && rt->rt_refcnt > 0)
+				panic("rtqkill route really not free");
+
+			err = in_rtrequest(RTM_DELETE,
+					(struct sockaddr *)rt_key(rt),
+					rt->rt_gateway, rt_mask(rt),
+					rt->rt_flags | RTF_RNH_LOCKED, 0,
+					rt->rt_fibnum);
+			if (err) {
+				log(LOG_WARNING, "in_rtqkill: error %d\n", err);
+			} else {
+				ap->killed++;
+			}
+		}
+	}
+
+	return 0;
+}
+
 int
 in_detachhead(void **head, int off)
 {
+	struct radix_node_head *rnh;
+	struct rtqk_arg arg;
 
 	callout_drain(&V_rtq_timer);
+
+	rnh = *head;
+
+	arg.found = arg.killed = 0;
+	arg.rnh = rnh;
+	arg.nextstop = 0;
+	arg.draining = 1;
+	arg.updating = 0;
+	RADIX_NODE_HEAD_LOCK(rnh);
+	//rnh->rnh_walktree(rnh, in_rtqkill_hard, &arg);
+	rnh->rnh_walktree(rnh, in_rtqkill, &arg);
+	RADIX_NODE_HEAD_UNLOCK(rnh);
+
+	/*
+	printf("%s: found=%d killed=%d\n",
+		__func__, arg.found, arg.killed);
+	*/
+
+	/* XXX determine if tree is actually as empty as it can be. */
+	rn_detachhead(head);
+
 	return (1);
 }
 #endif
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/netinet/ip_divert.c head/sys/netinet/ip_divert.c
--- clean-head/sys/netinet/ip_divert.c	2013-06-26 09:35:37.000000000 +0200
+++ head/sys/netinet/ip_divert.c	2013-06-24 14:20:40.000000000 +0200
@@ -156,7 +156,11 @@ div_init(void)
 	 * place for hashbase == NULL.
 	 */
 	in_pcbinfo_init(&V_divcbinfo, "div", &V_divcb, 1, 1, "divcb",
+#ifdef VIMAGE
+	    div_inpcb_init, div_inpcb_fini, 0,
+#else
 	    div_inpcb_init, div_inpcb_fini, UMA_ZONE_NOFREE,
+#endif
 	    IPI_HASHFIELDS_NONE);
 }
 
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/netinet/ip_input.c head/sys/netinet/ip_input.c
--- clean-head/sys/netinet/ip_input.c	2013-06-26 09:35:38.000000000 +0200
+++ head/sys/netinet/ip_input.c	2013-06-24 14:20:39.000000000 +0200
@@ -425,6 +425,10 @@ ip_destroy(void)
 	IPQ_UNLOCK();
 
 	uma_zdestroy(V_ipq_zone);
+
+#ifdef FLOWTABLE
+	flowtable_destroy(V_ip_ft);
+#endif /* FLOWTABLE */
 }
 #endif
 
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/netinet/raw_ip.c head/sys/netinet/raw_ip.c
--- clean-head/sys/netinet/raw_ip.c	2013-06-26 09:35:36.000000000 +0200
+++ head/sys/netinet/raw_ip.c	2013-06-24 14:20:40.000000000 +0200
@@ -205,7 +205,11 @@ rip_init(void)
 {
 
 	in_pcbinfo_init(&V_ripcbinfo, "rip", &V_ripcb, INP_PCBHASH_RAW_SIZE,
+#ifdef VIMAGE
+	    1, "ripcb", rip_inpcb_init, NULL, 0,
+#else
 	    1, "ripcb", rip_inpcb_init, NULL, UMA_ZONE_NOFREE,
+#endif
 	    IPI_HASHFIELDS_NONE);
 	EVENTHANDLER_REGISTER(maxsockets_change, rip_zone_change, NULL,
 	    EVENTHANDLER_PRI_ANY);
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/netinet/tcp_input.c head/sys/netinet/tcp_input.c
--- clean-head/sys/netinet/tcp_input.c	2013-06-26 09:35:38.000000000 +0200
+++ head/sys/netinet/tcp_input.c	2013-06-24 14:20:39.000000000 +0200
@@ -70,6 +70,9 @@ __FBSDID("$FreeBSD: head/sys/netinet/tcp
 #include <sys/syslog.h>
 #include <sys/systm.h>
 
+#include <vps/vps.h>
+#include <vps/vps2.h>
+
 #include <machine/cpu.h>	/* before tcp_seq.h, for tcp_random18() */
 
 #include <vm/uma.h>
@@ -646,6 +649,14 @@ tcp_input(struct mbuf *m, int off0)
 	short ostate = 0;
 #endif
 
+#ifdef VPS
+	int vnet_vps_flags = curthread->td_vnet->vnet_vps_flags;
+
+	if (vnet_vps_flags & VPS_VNET_ABORT ||
+	    vnet_vps_flags & VPS_VNET_SUSPENDED)
+		goto drop;
+#endif
+
 #ifdef INET6
 	isipv6 = (mtod(m, struct ip *)->ip_v == 6) ? 1 : 0;
 #endif
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/netinet/tcp_output.c head/sys/netinet/tcp_output.c
--- clean-head/sys/netinet/tcp_output.c	2013-06-26 09:35:37.000000000 +0200
+++ head/sys/netinet/tcp_output.c	2013-06-24 14:20:39.000000000 +0200
@@ -50,6 +50,10 @@ __FBSDID("$FreeBSD: head/sys/netinet/tcp
 #include <sys/socketvar.h>
 #include <sys/sysctl.h>
 
+#include <sys/proc.h>
+#include <vps/vps.h>
+#include <vps/vps2.h>
+
 #include <net/if.h>
 #include <net/route.h>
 #include <net/vnet.h>
@@ -194,6 +198,29 @@ tcp_output(struct tcpcb *tp)
 
 	INP_WLOCK_ASSERT(tp->t_inpcb);
 
+#ifdef VPS
+	if (so->so_vnet->vnet_vps_flags & VPS_VNET_ABORT) {
+		printf("%s: VPS_VNET_ABORT --> returning 0, so=%p\n",
+			__func__, so);
+		return (0);
+	}
+	
+	/*
+	 * This can actually happen because we set the suspended flag
+	 * first and then suspend thread by thread ...
+	 * Better don't panic but return with EAGAIN.
+	 * XXX But make sure common user programs can deal with it.
+	 *
+	KASSERT( ! (so->so_vnet->vnet_vps_flags & VPS_VNET_SUSPENDED),
+		("%s: SUSPENDED vnet %p\n", __func__, so->so_vnet));
+	 */
+	if (so->so_vnet->vnet_vps_flags & VPS_VNET_SUSPENDED) {
+		printf("%s: VPS_VNET_SUSPENDED --> returning EINTR, so=%p\n",
+			__func__, so);
+		return (EINTR);
+	}
+#endif
+
 #ifdef TCP_OFFLOAD
 	if (tp->t_flags & TF_TOE)
 		return (tcp_offload_output(tp));
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/netinet/tcp_reass.c head/sys/netinet/tcp_reass.c
--- clean-head/sys/netinet/tcp_reass.c	2013-06-26 09:35:37.000000000 +0200
+++ head/sys/netinet/tcp_reass.c	2013-06-24 14:20:40.000000000 +0200
@@ -118,7 +118,11 @@ tcp_reass_init(void)
 	TUNABLE_INT_FETCH("net.inet.tcp.reass.maxsegments",
 	    &V_tcp_reass_maxseg);
 	V_tcp_reass_zone = uma_zcreate("tcpreass", sizeof (struct tseg_qent),
+#ifdef VIMAGE
+	    NULL, NULL, NULL, NULL, UMA_ALIGN_PTR, 0);
+#else
 	    NULL, NULL, NULL, NULL, UMA_ALIGN_PTR, UMA_ZONE_NOFREE);
+#endif
 	/* Set the zone limit and read back the effective value. */
 	V_tcp_reass_maxseg = uma_zone_set_max(V_tcp_reass_zone,
 	    V_tcp_reass_maxseg);
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/netinet/tcp_subr.c head/sys/netinet/tcp_subr.c
--- clean-head/sys/netinet/tcp_subr.c	2013-06-26 09:35:37.000000000 +0200
+++ head/sys/netinet/tcp_subr.c	2013-06-24 14:20:39.000000000 +0200
@@ -58,6 +58,8 @@ __FBSDID("$FreeBSD: head/sys/netinet/tcp
 #include <sys/protosw.h>
 #include <sys/random.h>
 
+#include <vps/vps.h>
+
 #include <vm/uma.h>
 
 #include <net/route.h>
@@ -357,15 +359,31 @@ tcp_init(void)
 		    "clipped from %d to %d.\n", __func__, oldhashsize,
 		    hashsize);
 	}
+	/*
+	 * Until UMA supports draining a UMA_ZONE_NOFREE zone on destroy,
+	 * UMA_ZONE_NOFREE can't be specified here.
+	 */
 	in_pcbinfo_init(&V_tcbinfo, "tcp", &V_tcb, hashsize, hashsize,
+#ifdef VIMAGE
+	    "tcp_inpcb", tcp_inpcb_init, NULL, 0,
+#else
 	    "tcp_inpcb", tcp_inpcb_init, NULL, UMA_ZONE_NOFREE,
+#endif
 	    IPI_HASHFIELDS_4TUPLE);
 
 	/*
 	 * These have to be type stable for the benefit of the timers.
 	 */
+	/*
+	 * Until UMA supports draining a UMA_ZONE_NOFREE zone on destroy,
+	 * UMA_ZONE_NOFREE can't be specified here.
+	 */
 	V_tcpcb_zone = uma_zcreate("tcpcb", sizeof(struct tcpcb_mem),
-	    NULL, NULL, NULL, NULL, UMA_ALIGN_PTR, UMA_ZONE_NOFREE);
+#ifdef VIMAGE
+		NULL, NULL, NULL, NULL, UMA_ALIGN_PTR, 0);
+#else
+		NULL, NULL, NULL, NULL, UMA_ALIGN_PTR, UMA_ZONE_NOFREE);
+#endif
 	uma_zone_set_max(V_tcpcb_zone, maxsockets);
 	uma_zone_set_warning(V_tcpcb_zone, "kern.ipc.maxsockets limit reached");
 
@@ -376,7 +394,11 @@ tcp_init(void)
 
 	TUNABLE_INT_FETCH("net.inet.tcp.sack.enable", &V_tcp_do_sack);
 	V_sack_hole_zone = uma_zcreate("sackhole", sizeof(struct sackhole),
+#ifdef VIMAGE
+	    NULL, NULL, NULL, NULL, UMA_ALIGN_PTR, 0);
+#else
 	    NULL, NULL, NULL, NULL, UMA_ALIGN_PTR, UMA_ZONE_NOFREE);
+#endif
 
 	/* Skip initialization of globals for non-default instances. */
 	if (!IS_DEFAULT_VNET(curvnet))
@@ -436,6 +458,10 @@ tcp_destroy(void)
 	in_pcbinfo_destroy(&V_tcbinfo);
 	uma_zdestroy(V_sack_hole_zone);
 	uma_zdestroy(V_tcpcb_zone);
+
+	/* VPS */
+	hhook_head_deregister(V_tcp_hhh[HHOOK_TCP_EST_OUT]);
+	hhook_head_deregister(V_tcp_hhh[HHOOK_TCP_EST_IN]);
 }
 #endif
 
@@ -1275,7 +1301,7 @@ tcp_pcblist(SYSCTL_HANDLER_ARGS)
 	return (error);
 }
 
-SYSCTL_PROC(_net_inet_tcp, TCPCTL_PCBLIST, pcblist,
+SYSCTL_VNET_PROC(_net_inet_tcp, TCPCTL_PCBLIST, pcblist,
     CTLTYPE_OPAQUE | CTLFLAG_RD, NULL, 0,
     tcp_pcblist, "S,xtcpcb", "List of active TCP connections");
 
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/netinet/tcp_timewait.c head/sys/netinet/tcp_timewait.c
--- clean-head/sys/netinet/tcp_timewait.c	2013-06-26 09:35:39.000000000 +0200
+++ head/sys/netinet/tcp_timewait.c	2013-06-24 14:20:40.000000000 +0200
@@ -164,7 +164,11 @@ tcp_tw_init(void)
 {
 
 	V_tcptw_zone = uma_zcreate("tcptw", sizeof(struct tcptw),
+#ifdef VIMAGE
+	    NULL, NULL, NULL, NULL, UMA_ALIGN_PTR, 0);
+#else
 	    NULL, NULL, NULL, NULL, UMA_ALIGN_PTR, UMA_ZONE_NOFREE);
+#endif
 	TUNABLE_INT_FETCH("net.inet.tcp.maxtcptw", &maxtcptw);
 	if (maxtcptw == 0)
 		uma_zone_set_max(V_tcptw_zone, tcptw_auto_size());
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/netinet/tcp_usrreq.c head/sys/netinet/tcp_usrreq.c
--- clean-head/sys/netinet/tcp_usrreq.c	2013-06-26 09:35:36.000000000 +0200
+++ head/sys/netinet/tcp_usrreq.c	2013-06-24 14:20:40.000000000 +0200
@@ -59,6 +59,9 @@ __FBSDID("$FreeBSD: head/sys/netinet/tcp
 #include <sys/proc.h>
 #include <sys/jail.h>
 
+#include <vps/vps.h>
+#include <vps/vps2.h>
+
 #ifdef DDB
 #include <ddb/ddb.h>
 #endif
@@ -91,6 +94,10 @@ __FBSDID("$FreeBSD: head/sys/netinet/tcp
 #include <netinet/tcp_offload.h>
 #endif
 
+#ifdef VPS
+static void tcp_usr_abort(struct socket *so);
+#endif
+
 /*
  * TCP protocol interface to socket abstraction.
  */
@@ -587,6 +594,14 @@ tcp_usr_disconnect(struct socket *so)
 	int error = 0;
 
 	TCPDEBUG0;
+#ifdef VPS
+	if (so->so_vnet->vnet_vps_flags & VPS_VNET_ABORT) {
+		DBGCORE("%s: VPS_VNET_ABORT --> tcp_usr_abort(so=%p)\n",
+			__func__, so);
+		tcp_usr_abort(so);
+		return (0);
+	}
+#endif
 	INP_INFO_WLOCK(&V_tcbinfo);
 	inp = sotoinpcb(so);
 	KASSERT(inp != NULL, ("tcp_usr_disconnect: inp == NULL"));
@@ -978,6 +993,15 @@ tcp_usr_close(struct socket *so)
 	struct tcpcb *tp = NULL;
 	TCPDEBUG0;
 
+#ifdef VPS
+	if (so->so_vnet->vnet_vps_flags & VPS_VNET_ABORT) {
+		DBGCORE("%s: VPS_VNET_ABORT --> tcp_usr_abort(so=%p)\n",
+			__func__, so);
+		tcp_usr_abort(so);
+		return;
+	}
+#endif
+
 	inp = sotoinpcb(so);
 	KASSERT(inp != NULL, ("tcp_usr_close: inp == NULL"));
 
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/netinet/udp_usrreq.c head/sys/netinet/udp_usrreq.c
--- clean-head/sys/netinet/udp_usrreq.c	2013-06-26 09:35:38.000000000 +0200
+++ head/sys/netinet/udp_usrreq.c	2013-06-24 14:20:39.000000000 +0200
@@ -185,11 +185,27 @@ void
 udp_init(void)
 {
 
+	/*
+	 * Until UMA supports draining a UMA_ZONE_NOFREE zone on destroy,
+	 * UMA_ZONE_NOFREE can't be specified here.
+	 */
 	in_pcbinfo_init(&V_udbinfo, "udp", &V_udb, UDBHASHSIZE, UDBHASHSIZE,
+#ifdef VIMAGE
+	    "udp_inpcb", udp_inpcb_init, NULL, 0,
+#else
 	    "udp_inpcb", udp_inpcb_init, NULL, UMA_ZONE_NOFREE,
+#endif
 	    IPI_HASHFIELDS_2TUPLE);
+	/*
+	 * Until UMA supports draining a UMA_ZONE_NOFREE zone on destroy,
+	 * UMA_ZONE_NOFREE can't be specified here.
+	 */
 	V_udpcb_zone = uma_zcreate("udpcb", sizeof(struct udpcb),
+#ifdef VIMAGE
+	    NULL, NULL, NULL, NULL, UMA_ALIGN_PTR, 0);
+#else
 	    NULL, NULL, NULL, NULL, UMA_ALIGN_PTR, UMA_ZONE_NOFREE);
+#endif
 	uma_zone_set_max(V_udpcb_zone, maxsockets);
 	uma_zone_set_warning(V_udpcb_zone, "kern.ipc.maxsockets limit reached");
 	EVENTHANDLER_REGISTER(maxsockets_change, udp_zone_change, NULL,
@@ -797,7 +813,7 @@ udp_pcblist(SYSCTL_HANDLER_ARGS)
 	return (error);
 }
 
-SYSCTL_PROC(_net_inet_udp, UDPCTL_PCBLIST, pcblist,
+SYSCTL_VNET_PROC(_net_inet_udp, UDPCTL_PCBLIST, pcblist,
     CTLTYPE_OPAQUE | CTLFLAG_RD, NULL, 0,
     udp_pcblist, "S,xinpcb", "List of active UDP sockets");
 
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/netinet6/in6.c head/sys/netinet6/in6.c
--- clean-head/sys/netinet6/in6.c	2013-06-26 09:35:29.000000000 +0200
+++ head/sys/netinet6/in6.c	2013-06-24 14:21:41.000000000 +0200
@@ -2694,6 +2694,10 @@ in6_lltable_dump(struct lltable *llt, st
 			if (lle->la_flags & LLE_PUB)
 				ndpc.rtm.rtm_flags |= RTF_ANNOUNCE;
 
+			/* proxy */
+			if (lle->la_flags & LLE_PROXY)
+				ndpc.rtm.rtm_flags |= RTF_PROTO1;
+
 			sdl = &ndpc.sdl;
 			sdl->sdl_family = AF_LINK;
 			sdl->sdl_len = sizeof(*sdl);
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/netinet6/in6_ifattach.c head/sys/netinet6/in6_ifattach.c
--- clean-head/sys/netinet6/in6_ifattach.c	2013-06-26 09:35:29.000000000 +0200
+++ head/sys/netinet6/in6_ifattach.c	2013-06-24 14:21:41.000000000 +0200
@@ -275,6 +275,9 @@ found:
 #ifdef IFT_IEEE80211
 	case IFT_IEEE80211:
 #endif
+#ifdef VPS
+	case IFT_PROPVIRTUAL:
+#endif
 		/* IEEE802/EUI64 cases - what others? */
 		/* IEEE1394 uses 16byte length address starting with EUI64 */
 		if (addrlen > 8)
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/netinet6/in6_proto.c head/sys/netinet6/in6_proto.c
--- clean-head/sys/netinet6/in6_proto.c	2013-06-26 09:35:29.000000000 +0200
+++ head/sys/netinet6/in6_proto.c	2013-06-24 14:21:41.000000000 +0200
@@ -83,6 +83,8 @@ __FBSDID("$FreeBSD: head/sys/netinet6/in
 #include <sys/systm.h>
 #include <sys/sysctl.h>
 
+#include <vps/vps.h>
+
 #include <net/if.h>
 #include <net/radix.h>
 #include <net/route.h>
@@ -133,7 +135,7 @@ __FBSDID("$FreeBSD: head/sys/netinet6/in
 /*
  * TCP/IP protocol family: IP6, ICMP6, UDP, TCP.
  */
-FEATURE(inet6, "Internet Protocol version 6");
+_FEATURE(inet6, "Internet Protocol version 6", VPS_PUBLIC);
 
 extern	struct domain inet6domain;
 static	struct pr_usrreqs nousrreqs;
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/netinet6/in6_rmx.c head/sys/netinet6/in6_rmx.c
--- clean-head/sys/netinet6/in6_rmx.c	2013-06-26 09:35:29.000000000 +0200
+++ head/sys/netinet6/in6_rmx.c	2013-06-24 14:21:41.000000000 +0200
@@ -286,11 +286,75 @@ in6_inithead(void **head, int off)
 }
 
 #ifdef VIMAGE
+#if 0
+__attribute__ ((unused))
+static int
+in6_rtqkill_hard(struct radix_node *rn, void *rock)
+{
+	struct rtqk_arg *ap = rock;
+	struct rtentry *rt = (struct rtentry *)rn;
+	int err;
+
+	RADIX_NODE_HEAD_WLOCK_ASSERT(ap->rnh);
+
+	if (1) {
+		ap->found++;
+
+		if (1) {
+			if (0 && rt->rt_refcnt > 0)
+				panic("rtqkill route really not free");
+
+			err = rtrequest(RTM_DELETE,
+					(struct sockaddr *)rt_key(rt),
+					rt->rt_gateway, rt_mask(rt),
+					rt->rt_flags|RTF_RNH_LOCKED, 0);
+			if (err) {
+				log(LOG_WARNING, "in6_rtqkill: error %d", err);
+			} else {
+				ap->killed++;
+			}
+		}
+	}
+
+	return 0;
+}
+#endif /* 0 */
+
 int
 in6_detachhead(void **head, int off)
 {
+	/*
+	struct radix_node_head *rnh;
+	struct rtqk_arg arg;
+	*/
 
 	callout_drain(&V_rtq_mtutimer);
+
+#if 0
+	/* XXX 9.1.0 -> head: in6_rtqkill() does not exist anymore */
+
+	rnh = *head;
+	KASSERT(rnh == rt_tables_get_rnh(0, AF_INET6), ("rnh?"));
+
+	arg.found = arg.killed = 0;
+	arg.rnh = rnh;
+	arg.nextstop = 0;
+	arg.draining = 1;
+	arg.updating = 0;
+	RADIX_NODE_HEAD_LOCK(rnh);
+	//rnh->rnh_walktree(rnh, in6_rtqkill_hard, &arg);
+	rnh->rnh_walktree(rnh, in6_rtqkill, &arg);
+	RADIX_NODE_HEAD_UNLOCK(rnh);
+
+	/*
+	printf("%s: found=%d killed=%d\n",
+		__func__, arg.found, arg.killed);
+	*/
+
+	/* XXX determine if tree is actually as empty as it can be. */
+	rn_detachhead(head);
+#endif
+
 	return (1);
 }
 #endif
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/netinet6/ip6_input.c head/sys/netinet6/ip6_input.c
--- clean-head/sys/netinet6/ip6_input.c	2013-06-26 09:35:29.000000000 +0200
+++ head/sys/netinet6/ip6_input.c	2013-06-24 14:21:41.000000000 +0200
@@ -304,6 +304,10 @@ ip6_destroy()
 	hashdestroy(V_in6_ifaddrhashtbl, M_IFADDR, V_in6_ifaddrhmask);
 	nd6_destroy();
 	callout_drain(&V_in6_tmpaddrtimer_ch);
+
+#ifdef FLOWTABLE
+        //flowtable_destroy(V_ip6_ft);
+#endif /* FLOWTABLE */
 }
 #endif
 
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/netinet6/nd6.c head/sys/netinet6/nd6.c
--- clean-head/sys/netinet6/nd6.c	2013-06-26 09:35:29.000000000 +0200
+++ head/sys/netinet6/nd6.c	2013-06-24 14:21:41.000000000 +0200
@@ -1176,6 +1176,11 @@ nd6_rtrequest(int req, struct rtentry *r
 	gateway = (struct sockaddr_in6 *)rt->rt_gateway;
 	ifp = rt->rt_ifp;
 
+#ifdef VPS
+	if (rt->rt_flags & RTF_PROTO1)
+		return(nd6_rtrequest_koh(req, rt, info));
+#endif /* VPS */
+
 	switch (req) {
 	case RTM_ADD:
 		break;
